package dbclass;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import classes.DbClass;

import beans.Documento;


public class DocumentoJDBC implements DocumentoDAO{	

	private Connection con;
	
	
	public Documento insert(Documento documento) throws SQLException, ClassNotFoundException
	{
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		boolean check =  stm.execute("INSERT INTO documento (id, tipo, isento, taxa) VALUES (" +
				"NULL, '" + documento.getTipo() + "', '" + documento.getIsento() + "', '" + documento.getTaxa() + "')");
		
		
		if(check)
		{
			return documento;
		}	
		return null;	
	}
	
	public Documento update(Documento documento) throws SQLException, ClassNotFoundException
	{
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		boolean check = stm.execute("UPDATE documento SET tipo = '" + documento.getTipo() + "', isento = '" + documento.getIsento() +
				"', taxa = '" + documento.getTaxa() + "' WHERE id = '" + documento.getId() + "'");
		
		if(check)
		{
			return documento;
		}	
		return null;
	}

	public boolean delete(String tipo) throws ClassNotFoundException, SQLException {
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		boolean check = stm.execute("DELETE FROM documento WHERE tipo = '" + tipo + "' LIMIT 1");
		return check;
	}
	
	
	/* Lista de todos os documentos */
	public List<Documento> findAll() throws SQLException, ClassNotFoundException {
		List<Documento> documentos = new ArrayList<Documento>();
		
		con = DbClass.getConnection(); 
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM documento");
		
		
		while (result.next()) { 
			Documento documento = new Documento(result.getLong(1), result.getString(3), result.getString(4), result.getString(2));
			documentos.add(documento);
        }		
		return documentos;
	}

	/* Retorna um documento  */
	public Documento findById(long id) throws SQLException, ClassNotFoundException {
		Documento documento = null;
		
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM documento WHERE id = '" + id + "'");
		
		while (result.next()) {
			documento = new Documento(result.getLong(1), result.getString(3), result.getString(4), result.getString(2));
        }		
		return documento;
	}
	
	/* Retorna um documento  */
	public Documento findByTipo(String tipo) throws SQLException, ClassNotFoundException {
		Documento documento = null;
		
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM documento WHERE tipo = '" + tipo + "'");
		
		while (result.next()) {
			documento = new Documento(result.getLong(1), result.getString(3), result.getString(4), result.getString(2));
        }		
		return documento;
	}
	

}