package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Cadastro;


public interface CadastroDAO {
	
	public Cadastro insert(Cadastro cadastro) throws SQLException, ClassNotFoundException;
	
	public Cadastro update(Cadastro Cadastro) throws SQLException, ClassNotFoundException;
	
	public boolean delete(String nome) throws ClassNotFoundException, SQLException;
	
	public List<Cadastro> findAll() throws SQLException, ClassNotFoundException;
	
	public Cadastro findById(long id) throws SQLException, ClassNotFoundException;	
	
	public Cadastro findByNome(String nome) throws SQLException, ClassNotFoundException;	


}
