package dbclass;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import classes.DbClass;

import beans.Cadastro;


public class CadastroJDBC implements CadastroDAO{	

	private Connection con;
	
	
	public Cadastro insert(Cadastro cadastro) throws SQLException, ClassNotFoundException
	{
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		boolean check =  stm.execute("INSERT INTO cadastro (id, nome, mae, pai, datanascimento, telefone, celular, email, endereco, numero, complemento, estado, cep, datacadastro) VALUES (" +
				"NULL, '" + cadastro.getNome() + "', '" + cadastro.getMae() + "','" + cadastro.getPai() + "', '" + cadastro.getDatanascimento() + "', '" + cadastro.getTelefone() + "', '" + cadastro.getCelular() + "', '" + cadastro.getEmail() + "', '" + cadastro.getEndereco() + "', '" + cadastro.getNumero() + "', '" + cadastro.getComplemento() + "', '" + cadastro.getEstado() + "', '" + cadastro.getCep() + "', '" + cadastro.getDatacadastro() + "')");
		
		
		if(check)
		{
			return cadastro;
		}	
		return null;	
	}
	
	public Cadastro update(Cadastro cadastro) throws SQLException, ClassNotFoundException
	{
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		boolean check = stm.execute("UPDATE cadastro SET nome = '" + cadastro.getNome() + "', mae = '" + cadastro.getMae() + "',  pai = '" + cadastro.getPai() + "',  datanascimento = '" + cadastro.getDatanascimento() + "',  telefone = '" + cadastro.getTelefone() + "',  celular = '" + cadastro.getCelular() + "',  email = '" + cadastro.getEmail() + "',  endereco = '" + cadastro.getEndereco() + "',  numero = '" + cadastro.getNumero() + "',  complemento = '" + cadastro.getComplemento() + "',  estado = '" + cadastro.getEstado() + "',  cep = '" + cadastro.getCep() + "', datacadastro = '" + cadastro.getDatacadastro() + "' WHERE id = '" + cadastro.getId() + "'");
		if(check)
		{
			return cadastro;
		}	
		return null;
	}

	public boolean delete(String nome) throws ClassNotFoundException, SQLException {
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		boolean check = stm.execute("DELETE FROM cadastro WHERE nome = '" + nome + "' LIMIT 1");
		return check;
	}
	
	
	/* Lista de todos os cadastros */
	public List<Cadastro> findAll() throws SQLException, ClassNotFoundException {
		List<Cadastro> cadastros = new ArrayList<Cadastro>();
		
		con = DbClass.getConnection(); 
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM cadastro");
		
		
		while (result.next()) { 
			Cadastro cadastro = new Cadastro(result.getLong(1), result.getString(2), result.getString(3), result.getString(4), result.getString(5), result.getString(6), result.getString(7), result.getString(8), result.getString(9), result.getString(10), result.getString(11), result.getString(12), result.getString(13), result.getString(14));
			cadastros.add(cadastro);
        }		
		return cadastros;
	}

	/* Retorna um cadastro  */
	public Cadastro findById(long id) throws SQLException, ClassNotFoundException {
		Cadastro cadastro = null;
		
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM cadastro WHERE id = '" + id + "'");
		
		while (result.next()) {
			cadastro = new Cadastro(result.getLong(1), result.getString(2), result.getString(3), result.getString(4), result.getString(5), result.getString(6), result.getString(7), result.getString(8), result.getString(9), result.getString(10), result.getString(11), result.getString(12), result.getString(13), result.getString(14));;
        }		
		return cadastro;
	}
	
	/* Retorna um cadastro  */
	public Cadastro findByNome(String nome) throws SQLException, ClassNotFoundException {
		Cadastro cadastro = null;
		
		con = DbClass.getConnection();
		Statement stm = con.createStatement();
		
		ResultSet result;
		result = stm.executeQuery("SELECT * FROM cadastro WHERE nome = '" + nome + "'");
		
		while (result.next()) {
			cadastro = new Cadastro(result.getLong(1), result.getString(2), result.getString(3), result.getString(4), result.getString(5), result.getString(6), result.getString(7), result.getString(8), result.getString(9), result.getString(10), result.getString(11), result.getString(12), result.getString(13), result.getString(14));
        }		
		return cadastro;
	}
	

}