package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Documento;


public interface DocumentoDAO {
	
	public Documento insert(Documento documento) throws SQLException, ClassNotFoundException;
	
	public Documento update(Documento documento) throws SQLException, ClassNotFoundException;
	
	public boolean delete(String tipo) throws ClassNotFoundException, SQLException;
	
	public List<Documento> findAll() throws SQLException, ClassNotFoundException;
	
	public Documento findById(long id) throws SQLException, ClassNotFoundException;	
	
	public Documento findByTipo(String tipo) throws SQLException, ClassNotFoundException;	


}
