# MySQL-Front 5.1  (Build 1.5)

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE */;
/*!40101 SET SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES */;
/*!40103 SET SQL_NOTES='ON' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS */;
/*!40014 SET FOREIGN_KEY_CHECKS=0 */;


# Host: localhost    Database: egov
# ------------------------------------------------------
# Server version 5.1.32-community

DROP DATABASE IF EXISTS `egov`;
CREATE DATABASE `egov` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `egov`;

#
# Source for table cidadao
#

CREATE TABLE `cidadao` (
  `Id_cidadao` int(11) NOT NULL AUTO_INCREMENT,
  `nome` text,
  `mae` text,
  `pai` text,
  `datanascimento` text,
  `telefone` text,
  `celular` text,
  `email` text,
  `endereco` text,
  `numero` text,
  `complemento` text,
  `estado` text,
  `cep` text,
  `datacadastro` text,
  PRIMARY KEY (`Id_cidadao`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table cidadao
#
LOCK TABLES `cidadao` WRITE;
/*!40000 ALTER TABLE `cidadao` DISABLE KEYS */;

/*!40000 ALTER TABLE `cidadao` ENABLE KEYS */;
UNLOCK TABLES;

#
# Source for table documentos
#

CREATE TABLE `documentos` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `tipo` text,
  `isento` char(1) DEFAULT NULL,
  `taxa` text,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table documentos
#
LOCK TABLES `documentos` WRITE;
/*!40000 ALTER TABLE `documentos` DISABLE KEYS */;

/*!40000 ALTER TABLE `documentos` ENABLE KEYS */;
UNLOCK TABLES;

#
# Source for table pagaconta
#

CREATE TABLE `pagaconta` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Id_cidadao` int(11) DEFAULT NULL,
  `codigo_usuario` text,
  `servico` text,
  `valor` text,
  `vencimento` text,
  `datapago` text,
  `pendente` char(1) DEFAULT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table pagaconta
#
LOCK TABLES `pagaconta` WRITE;
/*!40000 ALTER TABLE `pagaconta` DISABLE KEYS */;

/*!40000 ALTER TABLE `pagaconta` ENABLE KEYS */;
UNLOCK TABLES;

#
# Source for table pagataxa
#

CREATE TABLE `pagataxa` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Id_cidadao` int(11) DEFAULT NULL,
  `documento` text,
  `valor` text,
  `vencimento` text,
  `datapago` varchar(255) DEFAULT NULL,
  `pendente` char(1) DEFAULT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

#
# Dumping data for table pagataxa
#
LOCK TABLES `pagataxa` WRITE;
/*!40000 ALTER TABLE `pagataxa` DISABLE KEYS */;

/*!40000 ALTER TABLE `pagataxa` ENABLE KEYS */;
UNLOCK TABLES;

/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
